SystemOrganization addCategory: #'PharoBot-UI'!

Object subclass: #PharoBotUI
	instanceVariableNames: 'codeEditorText tabGroup workspacesTabGroup builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotUI class methodsFor: 'interface opening' stamp: 'NahuelGarbezza 1/19/2012 17:17'!
open

	self new open! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/20/2012 10:04'!
buildCodeBrowserLabel

	^builder newRow: {
		builder newImage: ThemeIcons confirmIcon.
		builder newLabel: 'Codigo'.
	}! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/31/2012 00:14'!
buildCodeBrowserPanel

	|browser|
	browser := GLMTabulator new.
	browser
		row: [ :row | row column: #classes span: 30; column: #methods span: 70 ];
		row: #code.
	browser transmit to: #classes; andShow: [ :p |
		p list
			title: 'Clases'; display: #classes;
			act: [ :class | self createNewClass ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Nueva Clase';
			selectionAct: [ :class | self removeClass: class ] icon: GLMUIThemeExtraIcons glamorousRemove entitled: 'Eliminar Clase';
			act: [ :class | self importClass ] icon: GLMUIThemeExtraIcons glamorousUp entitled: 'Importar Clase';
			selectionAct: [ :class | self exportClass: class ] icon: GLMUIThemeExtraIcons glamorousDown entitled: 'Exportar Clase'
	].
	browser transmit from: #classes; to: #methods; andShow: [ :p |
		p list
			title: 'Metodos de instancia'; display: [ :class | class selectors ];
			act: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Agregar metodo';
			act: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousRemove entitled: 'Eliminar metodo'.
		p list
			title: 'Metodos de clase'; display: [ :class | class class selectors ];
			act: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Agregar metodo';
			act: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousRemove entitled: 'Eliminar metodo'.
	].
	browser transmit
		from: #classes;
		from: #methods;
		to: #code;
		andShow: [ :p | 
			p smalltalkCode
				display: [ :class :selector |
					[ class >> selector ] on: Error do: [ class class >> selector ]
				];
				title: 'Implementacion';
				smalltalkClass: [ :class :selector | class ];
				act: [ :text | text inspect ] icon: GLMUIThemeExtraIcons glamorousCancel on: $l entitled: 'Deshacer cambios';
				act: [ :text | text inspect ] icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Guardar metodo'.
		].

	^(browser startOn: PharoBotEnvironment)
		renderGlamorouslyOn: GLMMorphicRenderer new! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/20/2012 10:07'!
buildCodeBrowserTab

	^self buildCodeBrowserLabel -> self buildCodeBrowserPanel! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/31/2012 00:00'!
buildInspectorPanel

	| inspector |
	inspector := GLMFinder new. "variableSizePanes."
	inspector show: [ :a |
		a list
			"title: 'Inspector';"
			display: [ :obj | obj class instVarNames ]
			"dynamicActionsOnSelection: [ :list | self actionsFor: list ]"
	].
	^(inspector startOn: inspector)
		renderGlamorouslyOn: GLMMorphicRenderer new! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/20/2012 10:04'!
buildMainButtons

	^builder newRow: {
		builder
			newButtonFor: self
			action: #saveImage
			label: 'Guardar Ambiente'
			help: 'Guarda el estado del ambiente para ser cargado luego'.
		builder
			newButtonFor: self
			action: #quit
			label: 'Salir'
			help: 'Sale del ambiente'.
	}.! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/20/2012 10:08'!
buildMainPanel

	builder := UITheme builder.
	^builder newColumn: {
		self buildMainTabGroup.
		self buildMainButtons.
	}.! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/20/2012 10:08'!
buildMainTabGroup

	^tabGroup := builder newTabGroup: {
		self buildWorkspaceTab.
		self buildCodeBrowserTab.
	}.! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 2/1/2012 10:47'!
buildNewWorkspaceNamed: name

	| label panel |
	label := builder newRow: {
		builder newLabel: name.
		builder
			newCloseControlFor: nil
			action: [ "TODO" ]
			help: 'Elimina el workspace del ambiente'
	}.
	panel := Workspace new buildTextMorph.
	workspacesTabGroup addPage: panel label: label! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/20/2012 10:06'!
buildWorkspaceLabel

	^builder newRow: {
		builder newImage: ThemeIcons backIcon.
		builder newLabel: 'Pruebas'.
	}! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/30/2012 23:56'!
buildWorkspacePanel

	^builder newColumn: {
		self buildWorldArea.
		builder newRow: {
			self buildWorkspacesTabGroup.
			self buildInspectorPanel.
		}
	}! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/20/2012 10:06'!
buildWorkspaceTab

	^self buildWorkspaceLabel -> self buildWorkspacePanel! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/20/2012 10:09'!
buildWorkspacesTabGroup

	workspacesTabGroup := builder newTabGroup: {}.
	self buildNewWorkspaceNamed: 'Workspace 1'.
	^workspacesTabGroup! !

!PharoBotUI methodsFor: 'interface building' stamp: 'NahuelGarbezza 1/20/2012 10:07'!
buildWorldArea

	"TODO"
	^Morph new! !

!PharoBotUI methodsFor: 'interface opening' stamp: 'NahuelGarbezza 1/19/2012 22:17'!
open

	(self buildMainPanel openInWindowLabeled: 'PharoBot') extent: 800@600.! !
